void ProcessDialogEvent()
{
	ref NPChar;
	aref Link, NextDiag;
	string gov_kid, merch_kid, name, offer, gov_kid_pronoun;

	ref PChar = GetMainCharacter();

	if (PChar.sex == "man")
	{
		gov_kid = "daughter";
		gov_kid_pronoun = "she";
		merch_kid = "son";
	}
	else
	{
		gov_kid = "son";
		gov_kid_pronoun = "he";
		merch_kid = "daughter";
	}

	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makearef(NextDiag, NPChar.Dialog);
	
	switch(Dialog.CurrentNode)
	{
		// ----------------------------------- |  -  
		case "First time":
			Dialog.defAni = "dialog_stay1";
			Dialog.defCam = "1";
			Dialog.defSnd = "dialogs\0\017";
			Dialog.defLinkAni = "dialog_1";
			Dialog.defLinkCam = "1";
			Dialog.defLinkSnd = "dialogs\woman\024";
			Dialog.ani = "dialog_stay2";
			Dialog.cam = "1";
			Dialog.snd = "dialogs\0\009";

			dialog.text = DLG_TEXT[0] + GetMyFullName(NPChar) + DLG_TEXT[1] + GetMyAddressForm(NPChar, PChar, ADDR_CIVIL, false, false) + DLG_TEXT[2];		// changed from .spa to .por by KAM
			Link.l1 = DLG_TEXT[3] + GetMyFullName(PChar) + DLG_TEXT[4];
			Link.l1.go = "node_1";
			NextDiag.TempNode = "First time";
		break;

		case "node_1":
			dialog.text = DLG_TEXT[8];
			link.l1 = DLG_TEXT[9];
			link.l1.go = "quests";
			link.l2 = DLG_TEXT[10] + GetCharacterAddressForm(NPChar, ADDR_TITLE, false, false) + ".";
			link.l2.go = "node_2";
		break;

		case "node_2":
			dialog.text = DLG_TEXT[11];
			link.l1 = DLG_TEXT[12];
			link.l1.go = "exit";
		break;

		case "quests":
			dialog.text = DLG_TEXT[13] + GetMyAddressForm(NPChar, PChar, ADDR_CIVIL, false, false) + DLG_TEXT[14];		// changed from .spa to .por by KAM
			if (CheckQuestAttribute("kidnap", "Engaged"))
			{
				Preprocessor_Add("gov_kid", gov_kid);
				link.l2 = DLG_TEXT[15];
				link.l2.go = "congratulate";
			}
			link.l99 = DLG_TEXT[16];
			link.l99.go = "exit";
		break;

		case "congratulate":
			PreProcessor_Add("name", GetMyAddressForm(NPChar, characterFromID(PChar.quest.romance), ADDR_CIVIL, false, false) + " " + GetMyName(characterFromID(PChar.quest.romance)));
			dialog.text = DLG_TEXT[17] + GetMyLastName(PChar) + ".";
			link.l1 = DLG_TEXT[18];
			AddDialogExitQuest("congratulated_governor");
			link.l1.go = "exit";
		break;

		case "kidnap_threaten":
			dialog.text = GetMySimpleName(characterFromID("Grigorio Formoselle")) + DLG_TEXT[19] + gov_kid + ", " + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[20];
			link.l1 = DLG_TEXT[21] + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[22];
			link.l1.go = "kidnap_threaten2";
		break;

		case "kidnap_threaten2":
			dialog.text = DLG_TEXT[23];
			link.l1 = DLG_TEXT[24];
			link.l1.go = "kidnap_threaten3";
		break;

		case "kidnap_threaten3":
			dialog.text = DLG_TEXT[25] + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[26];
			link.l1 = DLG_TEXT[27];
			link.l1.go = "exit";
		break;

		case "ransom":
			dialog.text = DLG_TEXT[91];
			link.l1 = DLG_TEXT[92] + GetMyFullName(characterFromID(PChar.quest.romance)) + ".";
			link.l1.go = "ransom2";
		break;

		case "ransom2":
			dialog.text = DLG_TEXT[93] + GetMyName(characterFromID(PChar.quest.romance)) + ".";
			link.l1 = DLG_TEXT[94] + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[95] + gov_kid + DLG_TEXT[96];
			link.l1.go = "ransom3";
		break;

		case "ransom3":
			if (checkquestattribute("payroll_ship", "success"))
			{
				offer = DLG_TEXT[99];
				PChar.quest.kidnap.ransom = 40000;
			}
			else
			{
				offer = DLG_TEXT[100];
				PChar.quest.kidnap.ransom = 50000;
			}
			dialog.text = DLG_TEXT[97] + GetMySimpleName(characterFromID(PChar.quest.romance)) + " to " + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[98] + offer + DLG_TEXT[101] + gov_kid + DLG_TEXT[102];
			link.l1 = DLG_TEXT[103];
			link.l1.go = "ransom_accept";
			link.l2 = DLG_TEXT[104];
			link.l2.go = "ransom_reject";
		break;

		case "ransom_reject":
			AddDialogExitQuest("ransom_rejected");
			DialogExit();
			NextDiag.CurrentNode = NextDiag.TempNode;
		break;

		case "ransom_accept":
			dialog.text = DLG_TEXT[105];
			link.l1 = DLG_TEXT[106] + gov_kid + DLG_TEXT[107];
			link.l1.go = "ransom_deal";
		break;

		case "ransom_deal":
			dialog.text = DLG_TEXT[108];
			link.l1 = DLG_TEXT[109];
			AddDialogExitQuest("ransom_accepted");
			link.l1.go = "exit";
		break;

		case "revenge":
			dialog.text = DLG_TEXT[110];
			link.l1 = DLG_TEXT[111];
			AddDialogExitQuest("governors_revenge");
			link.l1.go = "exit";
		break;

		case "hostage_free":
			TakeItemFromCharacter(Pchar, "ExplainLetter");
			dialog.text = DLG_TEXT[91];
			link.l1 = DLG_TEXT[112] + GetMyAddressForm(NPChar, characterFromID(PChar.quest.romance), ADDR_CIVIL, false, false) + " " + GetMySimpleName(characterFromID(PChar.quest.romance)) + ".";
			link.l1.go = "hostage_free2";
		break;

		case "hostage_free2":
			dialog.text = DLG_TEXT[113];
			link.l1 = DLG_TEXT[114] + GetMyAddressForm(NPChar, characterFromID(PChar.quest.romance), ADDR_CIVIL, false, false) + " " + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[115];
			link.l1.go = "hostage_free3";
		break;

		case "hostage_free3":
			if(GetRMRelation(Pchar, SPAIN) > REL_WAR)
			{
				dialog.text = DLG_TEXT[116] + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[117] + gov_kid_pronoun + DLG_TEXT[118];
			}
			else
			{
				dialog.text = DLG_TEXT[116] + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[117] + gov_kid_pronoun + DLG_TEXT[119];
			}
			link.l1 = DLG_TEXT[120] + GetMyAddressForm(NPChar, characterFromID(PChar.quest.romance), ADDR_CIVIL, false, false) + " " + GetMyName(characterFromID(PChar.quest.romance)) + DLG_TEXT[121];
			AddDialogExitQuest("governor_relaxes");
			link.l1.go = "Exit";
		break;

		case "Exit":
			DialogExit();
			NextDiag.CurrentNode = NextDiag.TempNode;
		break;
	}
}
