//#include "DIALOGS\Morgan Terror_Dialog.h"
void ProcessDialogEvent()
{
	ref NPChar;
	aref Link, Diag; //NextDiag;
	int n;
	string gov_kid, merch_kid;

	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makearef(Diag, NPChar.Dialog);

	ref PChar = GetMainCharacter();

	if (PChar.sex == "man")
	{
		gov_kid = "daughter";
		merch_kid = "son";
	}
	else
	{
		gov_kid = "son";
		merch_kid = "daughter";
	}
	
	switch(Dialog.CurrentNode)
	{
		// -----------------------------------  -  
		
		case "exit":
			Diag.CurrentNode = Diag.TempNode; //"First time";
			DialogExit();
		break;

	
		case "First time":
			Dialog.defAni = "dialog_stay1";
			Dialog.defCam = "1";
			Dialog.defSnd = "dialogs\0\017";
			Dialog.defLinkAni = "dialog_1";
			Dialog.defLinkCam = "1";
			Dialog.defLinkSnd = "dialogs\woman\024";
			Dialog.ani = "dialog_stay2";
			Dialog.cam = "1";
			Dialog.snd = "dialogs\0\009";

			dialog.text = DLG_TEXT[0] + GetMyAddressForm(NPChar, PChar, ADDR_CIVIL, false, false) + ".";
			link.l1 = DLG_TEXT[1];
			link.l1.go = "Exit";
		break;

		case "intruder":
			dialog.text = DLG_TEXT[2];
			link.l1 = DLG_TEXT[3];
			link.l1.go = "threat";
			if (checkquestattribute("kidnap.wedding", "sad"))
			{
				link.l2 = DLG_TEXT[8];
				link.l2.go = "offer";
			}
		break;

		case "threat":
			PChar.quest.kidnap.status = "hostile";
			dialog.text = DLG_TEXT[4];
			link.l1 = DLG_TEXT[5];
			link.l1.go = "threat2";
		break;

		case "threat2":
			dialog.text = DLG_TEXT[6];
			link.l1 = DLG_TEXT[7];
			link.l1.go = "exit";
		break;

		case "offer":
			PChar.quest.kidnap.status = "cooperate";
			dialog.text = DLG_TEXT[9] + GetMyName(characterFromID(PChar.quest.villain)) + DLG_TEXT[10];
			link.l1 = DLG_TEXT[11] + GetMyName(characterFromID(PChar.quest.villain)) + ".";
			link.l1.go = "offer2";
		break;

		case "offer2":
			dialog.text = DLG_TEXT[12] + GetMyName(characterFromID("Grigorio Formoselle")) + "!";
			link.l1 = DLG_TEXT[13];
			link.l1.go = "offer3";
		break;

		case "offer3":
			dialog.text = DLG_TEXT[14] + GetMyName(characterFromID(PChar.quest.villain)) + DLG_TEXT[15];
			link.l1 = DLG_TEXT[16];
			link.l1.go = "exit";
		break;

		case "guard_help":
			dialog.text = DLG_TEXT[17];
			link.l1 = DLG_TEXT[18];
			AddDialogExitQuest("kidnap_battle");
			link.l1.go = "exit";
		break;

		case "answer_guard":
			dialog.text = DLG_TEXT[19];
			link.l1 = DLG_TEXT[20];
			AddDialogExitQuest("kidnap_cooperate");
			link.l1.go = "exit";
		break;

		case "apologise":
			dialog.text = DLG_TEXT[21];
			link.l1 = DLG_TEXT[22];
			link.l1.go = "exit";
		break;

		case "what_next":
			dialog.text = DLG_TEXT[23];
			if (checkquestattribute("kidnap.status", "cooperate"))
			{
				link.l1 = DLG_TEXT[24];
				link.l1.go = "kidnap_guest";
				link.l2 = DLG_TEXT[25];
				link.l2.go = "betrayed";
			}
			else
			{
				link.l1 = DLG_TEXT[25];
				AddDialogExitQuest("kidnap_prisoner");
				link.l1.go = "exit";
			}
		break;

		case "betrayed":
			if (PChar.quest.alignment == "good") ChangeCharacterReputation(pchar, -2);
			dialog.text = DLG_TEXT[26];
			link.l1 = DLG_TEXT[27];
			AddDialogExitQuest("kidnap_prisoner");
			link.l1.go = "exit";
		break;

		case "kidnap_guest":
			AddDialogExitQuest("kidnap_guest");
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;

		case "not_mistreated":
			dialog.text = DLG_TEXT[28];
			link.l1 = DLG_TEXT[29];
			link.l1.go = "exit";
		break;

		case "reached_a_decision":
			n = makeint(PChar.quest.kidnap.voyage_stage);
			dialog.text = DLG_TEXT[30];
			link.l3 = DLG_TEXT[31];		
			link.l3.go = "release";
			if (n >= 1)
			{
				link.l1 = DLG_TEXT[32];
				link.l1.go = "officer";
			}
			if (PChar.quest.alignment == "evil")
			{
				link.l2 = DLG_TEXT[25];
				link.l2.go = "betrayed";
			}
			if (PChar.quest.alignment == "good" && n >= 1)
			{
				link.l2 = DLG_TEXT[33];
				link.l2.go = "marry";
			}
			link.l4 = DLG_TEXT[34];
			link.l4.go = "exit_cabin";
		break;

		case "exit_cabin":
			Diag.CurrentNode = "reached_a_decision";
			DialogExit();
		break;

		case "release":
			dialog.text = DLG_TEXT[35] + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[36];
			link.l1 = DLG_TEXT[37];
			link.l1.go = "release_confirmed";
			link.l2 = DLG_TEXT[38];
			link.l2.go = "exit_cabin";
		break;

		case "release_confirmed":
			AddDialogExitQuest("release_guest");
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;

		case "officer":
			dialog.text = DLG_TEXT[39];
			link.l1 = DLG_TEXT[40];
			link.l1.go = "officer2";
		break;

		case "officer2":
			if (PChar.sex == "man") dialog.text = DLG_TEXT[41] + gov_kid + DLG_TEXT[42] + DLG_TEXT[43] + DLG_TEXT[45];
			else dialog.text = DLG_TEXT[41] + gov_kid + DLG_TEXT[42] + DLG_TEXT[44] + DLG_TEXT[45];
			link.l1 = DLG_TEXT[46];
			link.l1.go = "first_mate";
			link.l2 = DLG_TEXT[47];
			link.l2.go = "doctor";
			link.l3 = DLG_TEXT[48];
			link.l3.go = "carpenter";
		break;

		case "first_mate":
			AddDialogExitQuest("recruit_first_mate");
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;

		case "doctor":
			AddDialogExitQuest("recruit_doctor");
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;

		case "carpenter":
			AddDialogExitQuest("recruit_carpenter");
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;

		case "marry":
			dialog.text = DLG_TEXT[49] + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[50];
			link.l1 = DLG_TEXT[51];
			link.l1.go = "exit";
		break;

		case "letter":
			dialog.text = DLG_TEXT[52] + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[53];
			link.l1 = DLG_TEXT[54];
			link.l1.go = "exit_letter";
		break;

		case "exit_letter":
			Diag.CurrentNode = "letter_done";
			DialogExit();
		break;

		case "letter_done":
			dialog.text = DLG_TEXT[55];
			link.l1 = DLG_TEXT[56];
			AddDialogExitQuest("deliver_letter");
			link.l1.go = "exit_cabin";
		break;

		case "visit_father":
			dialog.text = DLG_TEXT[57];
			link.l1 = DLG_TEXT[58] + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[59];
			link.l1.go = "exit";
		break;

		case "just_released":
			dialog.text = DLG_TEXT[60] + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[61];
			link.l1 = DLG_TEXT[62];
			link.l1.go = "exit";
		break;

		case "bored_in_san_juan":
			dialog.text = DLG_TEXT[63] + GetMyName(PChar) + ".";
			link.l1 = DLG_TEXT[64];
			link.l1.go = "bored_in_san_juan2";
		break;

		case "bored_in_san_juan2":
			dialog.text = DLG_TEXT[65];
			link.l1 = DLG_TEXT[66];
			link.l1.go = "officer";
			link.l2 = DLG_TEXT[67] + GetMySimpleName(characterFromID(PChar.quest.villain)) + DLG_TEXT[68];
			link.l2.go = "marry";
			link.l3 = DLG_TEXT[69];
			link.l3 = "exit";
		break;

	}
}